#include<stdio.h>
#include<stdlib.h>
#include<windows.h>
#include<math.h>
#include<time.h>

const int MAX_LENGTH = 255;
const int MAP_WIDTH  = 70;
const int MAP_HEIGHT = 19;

struct Point { // egy testrsz pozcijnak trolsra
       int x;
       int y;
};

struct BodyPart { // egy testrsz pozcijnak trolsra
       int x;
       int y;
       int dir;
};

struct Point apple;
int sec=0;

struct Player {
       int dir; //irny: 0:ll 1:le 2:fel 3:balra 4:jobbra
       int lastDir;
       int length; //kgy hossza
       int score; //jatekos pontja
       struct Point lastBit; //utols testrsz pozci
       struct BodyPart body[MAX_LENGTH]; //testrszek
       short color;
};


/* Szveges kpernyn pozcionl */
void gotoxy(int x, int y) {
    HANDLE hConsoleOutput;
    COORD dwCursorPosition;
    
    dwCursorPosition.X = x;
    dwCursorPosition.Y = y;
    hConsoleOutput = GetStdHandle(STD_OUTPUT_HANDLE); 
    SetConsoleCursorPosition(hConsoleOutput,dwCursorPosition);
}

/* Belltja a rajzolsi sznt. 7 a default szrke */
void setColor(short color) {
     HANDLE hConsole;
     hConsole=GetStdHandle(STD_OUTPUT_HANDLE);
     SetConsoleTextAttribute(hConsole, color);
}

void resetPlayer(Player &p, int x, int y, short color) {
     p.dir = 0;
     p.length = 8;
     p.score = 0;
     p.color = color;
     for (int i=0; i<p.length; i++) {
         p.body[i].x = x;
         p.body[i].y = y;
         p.body[i].dir = 0;
     }
}

void drawPlayer(Player p) {
     setColor(p.color);
     gotoxy(p.lastBit.x,p.lastBit.y);
     printf(" "); //trli az utolso testreszt        
     
     for (int i=1; i<p.length; i++) {
         gotoxy(p.body[i].x,p.body[i].y);
         //205 =
         switch (p.body[i].dir) {
            case 0: printf("*"); break;
            case 1: printf("%c",186); break;
            case 2: printf("%c",186); break;
            case 3: printf("%c",205); break;
            case 4: printf("%c",205); break; 
            case 5: printf("%c",187); break; 
            case 6: printf("%c",201); break; 
            case 7: printf("%c",188); break; 
            case 8: printf("%c",200); break; 
            case 9: printf("%c",200); break; 
            case 10: printf("%c",200); break; 
            case 11: printf("%c",200); break; 
            case 12: printf("%c",200); break; 
         }
         //printf("*");
     }
     
     gotoxy(p.body[0].x,p.body[0].y); //fej kirajzolasa
     switch (p.dir) {
            case 1: printf("%c",31); break;
            case 2: printf("%c",30); break;
            case 3: printf("%c",17); break;
            case 4: printf("%c",16); break;
     }
}

void nextApple(Player &p, Player &p2) {
     int t=0;
     do {
        t=0;
        apple.x = rand()%(MAP_WIDTH-2)+1;
        apple.y = rand()%(MAP_HEIGHT-2)+2;
        for (int i=0; i<p.length; i++)
            if ((p.body[i].x == apple.x)&&
               (p.body[i].y == apple.y)) {
               t=1; break;
        }  
        for (int i=0; i<p2.length; i++)
            if ((p2.body[i].x == apple.x)&&
               (p2.body[i].y == apple.y)) {
               t=1; break;
        }       
     } while(t!=0);
}

void drawApple() {
     setColor(14);
     gotoxy(apple.x,apple.y);
     printf("\2");
}

void checkEatApple(Player &p, Player &p2) {
    if ((p.body[0].x == apple.x)&&
        (p.body[0].y == apple.y)) {
               nextApple(p,p2);
               p.score++;
               p.length++;           
    }
    if ((p2.body[0].x == apple.x)&&
        (p2.body[0].y == apple.y)) {
               nextApple(p,p2);
               p2.score++;
               p2.length++;           
    }
}

void movePlayer(Player &p) {              
     p.lastBit.x = p.body[p.length-1].x;
     p.lastBit.y = p.body[p.length-1].y;
     int x = p.body[0].x;
     int y = p.body[0].y;
     switch (p.dir) {
            case 1: {y++; p.body[0].dir=1; 
             if (p.lastDir==4) p.body[0].dir=5;
             if (p.lastDir==3) p.body[0].dir=6;
            break;}
            case 2: {y--; p.body[0].dir=2; 
             if (p.lastDir==4) p.body[0].dir=7;
             if (p.lastDir==3) p.body[0].dir=8;
            break;}
            case 3: {x--; p.body[0].dir=3; 
             if (p.lastDir==1) p.body[0].dir=7;
             if (p.lastDir==2) p.body[0].dir=5;
            break;}
            case 4: {x++; p.body[0].dir=4; 
             if (p.lastDir==1) p.body[0].dir=8;
             if (p.lastDir==2) p.body[0].dir=6;
            break;}
     }
     for (int i=p.length-1; i>0; i--) {
         p.body[i].x = p.body[i-1].x;
         p.body[i].y = p.body[i-1].y;
         p.body[i].dir = p.body[i-1].dir;
     }
     p.body[0].x = x; //fej j pozcija
     p.body[0].y = y;
}


void drawTable(Player p, Player p2) {
     setColor(8);
     gotoxy(0,0);
     printf("Length: %d  Score: %d          Time: %d          Length: %d  Score: %d",
      p.length,p.score,sec,
      p2.length,p2.score);
     for (int y=0; y<MAP_HEIGHT; y++)
         for (int x=0; x<MAP_WIDTH; x++) {
             if ((y==0)||(y==MAP_HEIGHT-1)||
                 (x==0)||(x==MAP_WIDTH-1)) {                 
                 gotoxy(x,y+1);
                 printf("%c",219);
             }
         }
}

int collided(Player p) {
    int x = p.body[0].x; //fej
    int y = p.body[0].y;

    if (x==0 || x==MAP_WIDTH ||
        y==1 || y==MAP_HEIGHT)
             return 1;

    if (p.dir!=0)
    for (int i=1; i<p.length; i++)
        if (x==p.body[i].x && y==p.body[i].y)
           return 1;    
           
    return 0;
}

int playerCollided(Player p, Player p2) {
    int x = p.body[0].x; //fej
    int y = p.body[0].y;

    if (x==0 || x==MAP_WIDTH ||
        y==1 || y==MAP_HEIGHT)
             return 1;

    if (p.dir!=0)
    for (int i=1; i<p2.length; i++)
        if (x==p2.body[i].x && y==p2.body[i].y)
           return 1;    
           
    return 0;
}

main() {
       srand( time(NULL) );
       struct Player p1,p2,p3; //jtkos
       long tick=99;
       
       resetPlayer(p1,10,10,11);
       resetPlayer(p2,MAP_WIDTH-10,10,12);
       nextApple(p1,p2);
       
       int fps=0, sleep_value=1, last_time=time(NULL);
       
       while (1) {             
             drawApple();
             drawPlayer(p1);
             drawPlayer(p2);
             if (collided(p1)||playerCollided(p1,p2)) {
                gotoxy(3,MAP_HEIGHT+2);
                printf("Player 2 WIN");
                getchar();
                return 0;
             }
             if (collided(p2)||playerCollided(p2,p1)) {
                gotoxy(3,MAP_HEIGHT+2);
                printf("Player 1 WIN");
                getchar();
                return 0;
             }
                          
             
             
             
             //LASSITAS
             if (sleep_value>0)
                Sleep(sleep_value);
             
             //FPS szmols
             fps++;
             if (time(NULL)-last_time>=1) {
                gotoxy(0,20);
                printf("%dFPS",fps);
                fps = 0;
                last_time = time(NULL);
             }
             if (fps>5) sleep_value++;
             if (fps<5) sleep_value--;
             gotoxy(1,21);
             printf("%d",sleep_value);
             
             
             
             tick++;
             if (!(tick%100)) {
                sec++;
                drawTable(p1,p2);
             }
             //if (!(tick%10)) { 
                     // PLAYER1 IRNYTSA
                     p1.lastDir = p1.dir;
                     if (GetAsyncKeyState(VK_LEFT))
                        if (p1.dir==4)
                           p1.dir = 4;
                        else
                            p1.dir = 3;
                     if (GetAsyncKeyState(VK_RIGHT))
                        if (p1.dir==3)
                           p1.dir = 3;
                        else
                        p1.dir = 4;
                     if (GetAsyncKeyState(VK_UP))
                        if (p1.dir==1)
                           p1.dir = 1;
                        else
                        p1.dir = 2;
                     if (GetAsyncKeyState(VK_DOWN))
                        if (p1.dir==2)
                           p1.dir = 2;
                        else
                        p1.dir = 1; 
                     
                     // PLAYER2 IRNYTSA
                     p2.lastDir = p2.dir;                     
                     if (GetAsyncKeyState(65))  //A
                        if (p2.dir==4)
                           p2.dir = 4;
                        else
                            p2.dir = 3;
                     if (GetAsyncKeyState(68))  //D
                        if (p2.dir==3)
                           p2.dir = 3;
                        else
                        p2.dir = 4;
                     if (GetAsyncKeyState(87))  //W
                        if (p2.dir==1)
                           p2.dir = 1;
                        else
                        p2.dir = 2;
                     if (GetAsyncKeyState(83))  //S
                        if (p2.dir==2)
                           p2.dir = 2;
                        else
                        p2.dir = 1;   
                        
                     movePlayer(p1);
                     movePlayer(p2);
                     checkEatApple(p1,p2);
            // }             
                
             
             if (GetAsyncKeyState(VK_ESCAPE))
              break;
       }
}
